-- Test add_campsite_carousel_slide
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text']);
select function_lang_is('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'sql');
select function_returns('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'integer');
select isnt_definer('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text']);
select volatility_is('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'volatile');
select function_privs_are('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_campsite_carousel_slide', array['integer', 'text', 'integer', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_carousel cascade;
truncate campsite cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (4, 2, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (5, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (6, 1, 'text.txt', sha256('hello, world!'))
     , (7, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, max_campers, bookable_nights, active)
values (10, 1, 3, 'Type A', '<p>A</p>', 5, '[1, 7]', true)
     , (11, 2, 4, 'Type A', '<p>A</p>', 5, '[2, 5]', true)
;

insert into campsite (campsite_id, company_id, label, campsite_type_id)
values (11, 1, 'A1', 10)
     , (12, 1, 'Z9', 10)
     , (13, 2, 'A1', 11)
;

insert into campsite_carousel (campsite_id, media_id, caption)
values (11, 5, 'A caption')
;

select lives_ok(
	$$ select add_campsite_carousel_slide(1, 'A1', 6, 'A caption') $$,
	'Should be able to add a carousel slide with a caption'
);

select lives_ok(
	$$ select add_campsite_carousel_slide(1, 'Z9', 7, null) $$,
	'Should be able to add a carousel slide without caption'
);

select lives_ok(
	$$ select add_campsite_carousel_slide(1, 'A1', 5, 'New caption') $$,
	'Should be able to overwrite a slide with a new caption'
);

select bag_eq(
	$$ select campsite_id, media_id, caption from campsite_carousel $$,
	$$ values (11, 5, 'New caption')
	        , (11, 6, 'A caption')
	        , (12, 7, '')
	$$,
	'Should have all three slides'
);

select *
from finish();

rollback;
